part of viltage;

class Utility {
	static render(List<List<Entity>> entities, List<List<Node>> nodeArray) {
		for(int i = 0; i < entities.length; i++) {
			for(int j = 0; j < entities[i].length; j++) {
				entities[i][j].render(nodeArray);
			}
		}
	}
	  
	static draw(CanvasRenderingContext2D ctx, int offX, int offY, VilTAGE viltage) {
	  for(int i = 0; i < viltage.nodeArray.length; i++) {
			for(int j = 0; j < viltage.nodeArray[0].length; j++) {
			  ctx.drawImage(getImage(viltage.nodeArray[i][j], viltage), j*offX, i*offY);
  		}
	  }
	}
	
	static bool printCaching = false;
	
	static CanvasElement getImage(Node node, VilTAGE viltage) {
	  CanvasElement image;
    
	  if(node is CharNode) {
	    image = cachedCharNodes[node.getString(viltage)];
  	  
  	  if(image == null) {
  	    image = createImage(node, viltage);
  	    if(printCaching) print('Cached "${node.char}" background color: "${node.backgroundColor==null?viltage.backgroundColor:node.backgroundColor}" color: "${node.color}" font: "${node.fontName==null?viltage.fontName:node.fontName}" bold: "${node.bold==null?viltage.bold:node.bold}" italic: "${node.italic==null?viltage.italic:node.italic}"');
  	  }
	  } else if(node is ImgNode) {
	    image = node.image;
	  }
	  
	  return image;
	}
	
	static CanvasElement createImage(CharNode cn, VilTAGE viltage) {
	  CanvasElement ce = new CanvasElement(width: viltage.offX, height: viltage.offY);
	  
	  if(cn.backgroundColor == null) ce.context2D.fillStyle = viltage.backgroundColor;
	  else ce.context2D.fillStyle = cn.backgroundColor;
	  ce.context2D.fillRect(0, 0, ce.width, ce.height);
	  if(cn.char != null && ce.text != " " && cn.char.length <= 1) {
      ce.context2D.fillStyle = cn.color;
  
      String italic = viltage.italic?"italic":"";
      if(cn.italic != null) italic = cn.italic?"italic":"";
      String bold = viltage.bold?"bold":"";
      if(cn.bold!= null) bold = cn.bold?"bold":"";
  	  ce.context2D.font = "$italic $bold ${viltage.fontSize}px ${cn.fontName==null?viltage.fontName:cn.fontName}";
 // 	  double width = viltage.ce.context2D.measureText(cn.char).width;
  	  ce.context2D.fillText(cn.char, (viltage.offX-viltage.fontSize)/2, viltage.offY/3*2 + viltage.fontSize/10);
	  }
	  cachedCharNodes[cn.getString(viltage)] = ce;
	  return ce;
	}
	
	/* stores String and CanvasElement pairs */
	static HashMap<String, CanvasElement> cachedCharNodes = new HashMap<String, CanvasElement>();
	
	static update(VilTAGEScreen screen, double delta) {
		for(int i = 0; i < screen.entities.length; i++) {
			for(int j = 0; j < screen.entities[i].length; j++) {
				if(screen.entities[i][j].active) {
				  screen.entities[i][j].update(delta);
				  screen.entities[i][j].updateAnimations(delta);
			  }
			}
		}
	}
}